(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('dc-scc'), require('dc-eas-api'), require('dc-dds-api')) :
    typeof define === 'function' && define.amd ? define('dc-unr-api', ['exports', '@angular/core', 'dc-scc', 'dc-eas-api', 'dc-dds-api'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['dc-unr-api'] = {}, global.ng.core, global['dc-scc'], global['dc-eas-api'], global['dc-dds-api']));
}(this, (function (exports, i0, i1, i2, dcDdsApi) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var BaseFactory = /** @class */ (function (_super) {
        __extends(BaseFactory, _super);
        function BaseFactory() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BaseFactory.prototype.newRequest = function () {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            return [2 /*return*/, reqObj];
                    }
                });
            });
        };
        BaseFactory.prototype.clearCache = function (obj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    if (typeof this._s[obj.getGuid()] != "undefined") {
                        delete this._s[obj.getGuid()];
                    }
                    return [2 /*return*/, this];
                });
            });
        };
        BaseFactory.prototype.getByGuids = function (guids, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var utilObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            utilObj = this.getService().getDcScc().getUtilities().getFactories().getAsyncGuids();
                            return [4 /*yield*/, utilObj.getByGuids(guids, this, "getByGuid", cbObj, cbMethod)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        return BaseFactory;
    }(i1.DcSccBaseFactory));

    var Connection = /** @class */ (function (_super) {
        __extends(Connection, _super);
        function Connection() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._wsHost = "dc-wss-nlb.datacamo.net";
            _this._wsPort = 28109;
            _this._wsSsl = true;
            _this._isReconn = false;
            _this._wrkObj = null;
            return _this;
        }
        Connection.prototype.setConfig = function (host, port, ssl) {
            if (ssl === void 0) { ssl = true; }
            this._wsHost = host;
            this._wsPort = port;
            this._wsSsl = ssl;
            return this;
        };
        Connection.prototype.getClient = function () {
            return __awaiter(this, void 0, void 0, function () {
                var wrkObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getWorker()];
                        case 1:
                            wrkObj = _a.sent();
                            return [2 /*return*/, wrkObj.getClient()];
                    }
                });
            });
        };
        Connection.prototype.getWorker = function () {
            return __awaiter(this, void 0, void 0, function () {
                var cObj, reqObj, salt, reqObj, hash, ephKey, sessObj, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this._wrkObj === null)) return [3 /*break*/, 9];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 8, , 9]);
                            this._wrkObj = this.getService().getDcScc().getWorkers().getV3(this._wsHost, this._wsPort, this._wsSsl);
                            return [4 /*yield*/, this._wrkObj.initialize()];
                        case 2:
                            _a.sent();
                            cObj = this._wrkObj.getClient();
                            reqObj = cObj.newMessage();
                            reqObj.setL1("Authentication").setL2("Get").setL3("Salt");
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            salt = _a.sent();
                            reqObj = cObj.newMessage();
                            reqObj.setL1("Authentication").setL2("Validate").setL3("ByEAS").setL4("EphemeralKey");
                            return [4 /*yield*/, this.getMtm().get("utilities").getHashing().getSHA().get256("UNR--" + salt)];
                        case 4:
                            hash = _a.sent();
                            return [4 /*yield*/, this.getMtm().get("DcEasApi").getEphemeralKeys().newReadUserPublic()];
                        case 5:
                            ephKey = _a.sent();
                            return [4 /*yield*/, ephKey.signRequest(reqObj, hash)];
                        case 6:
                            _a.sent();
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 7:
                            sessObj = _a.sent();
                            if (typeof sessObj["session-id"] != "undefined"
                                && typeof sessObj["session-key"] != "undefined") {
                                cObj.setSession(sessObj["session-id"], sessObj["session-key"]);
                                this._wrkObj.setTermCb(this, "reconnect");
                            }
                            else {
                                throw this.getMtm().newException("Server authentication returned an invalid session");
                            }
                            return [3 /*break*/, 9];
                        case 8:
                            errObj_1 = _a.sent();
                            this._wrkObj = null;
                            throw errObj_1;
                        case 9: return [2 /*return*/, this._wrkObj];
                    }
                });
            });
        };
        Connection.prototype.reconnect = function (wrkObj) {
            return __awaiter(this, void 0, void 0, function () {
                var errObj_2, errObj_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this._isReconn === false)) return [3 /*break*/, 7];
                            this._isReconn = true;
                            this.logInfo("UNR Reconnecting");
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 6, , 7]);
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 4, , 5]);
                            this._wrkObj = null;
                            return [4 /*yield*/, this.getWorker()];
                        case 3:
                            _a.sent();
                            this._isReconn = false;
                            this.logInfo("UNR Reconnect success");
                            return [3 /*break*/, 5];
                        case 4:
                            errObj_2 = _a.sent();
                            throw this.getService().getMtm().newException("UNR Reconnect failed");
                        case 5: return [3 /*break*/, 7];
                        case 6:
                            errObj_3 = _a.sent();
                            this._isReconn = false;
                            this.callException(errObj_3);
                            return [3 /*break*/, 7];
                        case 7: return [2 /*return*/];
                    }
                });
            });
        };
        return Connection;
    }(BaseFactory));

    var Base = /** @class */ (function (_super) {
        __extends(Base, _super);
        function Base() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._guid = null;
            return _this;
        }
        Base.prototype.baseConstruct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                var ddsObj, storeObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.setExceptionCb(this.getService().getLogging(), "exception");
                            this._guid = apiObj.guid;
                            if (!(typeof apiObj["ddsId"] != "undefined")) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.getService().getDdsClient()];
                        case 1:
                            ddsObj = _a.sent();
                            this.setConfig(ddsObj, apiObj.ddsId, apiObj.ddsAuth);
                            return [4 /*yield*/, this.pubStore()];
                        case 2:
                            storeObj = _a.sent();
                            return [4 /*yield*/, storeObj.initialize()];
                        case 3:
                            _a.sent();
                            _a.label = 4;
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        Base.prototype.getGuid = function () {
            return this._guid;
        };
        Base.prototype.newRequest = function () {
            return __awaiter(this, void 0, void 0, function () {
                var reqObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            return [2 /*return*/, reqObj];
                    }
                });
            });
        };
        return Base;
    }(dcDdsApi.DcDdsObjectModelV1));

    var User = /** @class */ (function (_super) {
        __extends(User, _super);
        function User() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._nsGuids = null;
            return _this;
        }
        User.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                var storeObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.pubStore()];
                        case 2:
                            storeObj = _a.sent();
                            storeObj.addUpdateCb(this, "ddsUpdateCb");
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        User.prototype.getDisplayName = function () {
            return this.getPubKey("displayName", true);
        };
        User.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        User.prototype.getNsMaps = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, _a, rObjs, _b, _c, _i, guid, rObj;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            if (!(this._nsGuids === null)) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _d.sent();
                            reqObj.setL1("RoleNsMaps").setL2("Get").setL3("ByUser");
                            reqObj.addReq("guid", this.getGuid());
                            _a = this;
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 2:
                            _a._nsGuids = _d.sent();
                            _d.label = 3;
                        case 3:
                            rObjs = [];
                            _b = [];
                            for (_c in this._nsGuids)
                                _b.push(_c);
                            _i = 0;
                            _d.label = 4;
                        case 4:
                            if (!(_i < _b.length)) return [3 /*break*/, 7];
                            guid = _b[_i];
                            return [4 /*yield*/, this.getService().getRoleNsMaps().getByGuid(guid, cbObj, cbMethod)];
                        case 5:
                            rObj = _d.sent();
                            rObjs.push(rObj);
                            _d.label = 6;
                        case 6:
                            _i++;
                            return [3 /*break*/, 4];
                        case 7: return [2 /*return*/, rObjs];
                    }
                });
            });
        };
        User.prototype.getNsMapByGuid = function (guid, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, rObjs, i, rObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this._nsGuids === null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("RoleNsMaps").setL2("Get").setL3("ByUser");
                            reqObj.addReq("guid", this.getGuid());
                            this._nsGuids = reqObj.getResponse(true);
                            _a.label = 2;
                        case 2: return [4 /*yield*/, this.getNsMaps()];
                        case 3:
                            rObjs = _a.sent();
                            for (i = 0; i < rObjs.length; i++) {
                                rObj = rObjs[i];
                                if (rObj.getGuid() === guid) {
                                    return [2 /*return*/, rObj];
                                }
                            }
                            if (throwOnErr === true) {
                                throw this.getMtm().newException("No ns map with that guid");
                            }
                            else {
                                return [2 /*return*/, null];
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        User.prototype.ddsUpdateCb = function (storeObj) {
            this._nsGuids = null;
        };
        User.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getUsers().clearCache(this);
        };
        return User;
    }(Base));

    var Users = /** @class */ (function (_super) {
        __extends(Users, _super);
        function Users() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Users.prototype.newObj = function () {
            var rObj = new User();
            rObj.setService(this.getService());
            return rObj;
        };
        Users.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        Users.prototype.getBySession = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, guids, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Get").setL3("BySession");
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 5, , 6]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 3:
                            guids = _a.sent();
                            return [4 /*yield*/, this.getByGuids(guids, cbObj, cbMethod)];
                        case 4: return [2 /*return*/, _a.sent()];
                        case 5:
                            errObj_1 = _a.sent();
                            this.callException(errObj_1);
                            throw errObj_1;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
        Users.prototype.getByConnection = function () {
            return __awaiter(this, void 0, void 0, function () {
                var easUser, reqObj, apiObj, errObj_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getMtm().get("DcEasApi").getUsers().getBySession()];
                        case 1:
                            easUser = _a.sent();
                            return [4 /*yield*/, this.newRequest()];
                        case 2:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Get").setL3("ByEasGuid");
                            reqObj.addReq("guid", easUser.getPermGuid());
                            _a.label = 3;
                        case 3:
                            _a.trys.push([3, 6, , 7]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 4:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 5: return [2 /*return*/, _a.sent()];
                        case 6:
                            errObj_2 = _a.sent();
                            this.callException(errObj_2);
                            throw errObj_2;
                        case 7: return [2 /*return*/];
                    }
                });
            });
        };
        Users.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("Users").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_3 = _a.sent();
                            throw errObj_3;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return Users;
    }(BaseFactory));

    var Role = /** @class */ (function (_super) {
        __extends(Role, _super);
        function Role() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._privGuids = null;
            return _this;
        }
        Role.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                var storeObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.pubStore()];
                        case 2:
                            storeObj = _a.sent();
                            storeObj.addUpdateCb(this, "ddsUpdateCb");
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        Role.prototype.getLabel = function () {
            return this.getPubKey("label", true);
        };
        Role.prototype.getDisplayName = function () {
            return this.getPubKey("displayName", true);
        };
        Role.prototype.getDescription = function () {
            return this.getPubKey("desc", true);
        };
        Role.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        Role.prototype.getPrivilegeMaps = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, _a, rObjs, _b, _c, _i, guid, rObj;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            if (!(this._privGuids === null)) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _d.sent();
                            reqObj.setL1("RolePrivilegeMaps").setL2("Get").setL3("ByRole");
                            reqObj.addReq("guid", this.getGuid());
                            _a = this;
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 2:
                            _a._privGuids = _d.sent();
                            _d.label = 3;
                        case 3:
                            rObjs = [];
                            _b = [];
                            for (_c in this._privGuids)
                                _b.push(_c);
                            _i = 0;
                            _d.label = 4;
                        case 4:
                            if (!(_i < _b.length)) return [3 /*break*/, 7];
                            guid = _b[_i];
                            return [4 /*yield*/, this.getService().getRolePriviligeMaps().getByGuid(guid, cbObj, cbMethod)];
                        case 5:
                            rObj = _d.sent();
                            rObjs.push(rObj);
                            _d.label = 6;
                        case 6:
                            _i++;
                            return [3 /*break*/, 4];
                        case 7: return [2 /*return*/, rObjs];
                    }
                });
            });
        };
        Role.prototype.ddsUpdateCb = function (storeObj) {
            this._privGuids = null;
        };
        Role.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getRoles().clearCache(this);
        };
        return Role;
    }(Base));

    var Roles = /** @class */ (function (_super) {
        __extends(Roles, _super);
        function Roles() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Roles.prototype.newObj = function () {
            var rObj = new Role();
            rObj.setService(this.getService());
            return rObj;
        };
        Roles.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        Roles.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("Roles").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_1 = _a.sent();
                            throw errObj_1;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return Roles;
    }(BaseFactory));

    var Privilege = /** @class */ (function (_super) {
        __extends(Privilege, _super);
        function Privilege() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Privilege.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        Privilege.prototype.getLabel = function () {
            return this.getPubKey("label", true);
        };
        Privilege.prototype.getDisplayName = function () {
            return this.getPubKey("displayName", true);
        };
        Privilege.prototype.getDescription = function () {
            return this.getPubKey("desc", true);
        };
        Privilege.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        Privilege.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getPrivileges().clearCache(this);
        };
        return Privilege;
    }(Base));

    var Privileges = /** @class */ (function (_super) {
        __extends(Privileges, _super);
        function Privileges() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Privileges.prototype.newObj = function () {
            var rObj = new Privilege();
            rObj.setService(this.getService());
            return rObj;
        };
        Privileges.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        Privileges.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("Privileges").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_1 = _a.sent();
                            throw errObj_1;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return Privileges;
    }(BaseFactory));

    var NSpace = /** @class */ (function (_super) {
        __extends(NSpace, _super);
        function NSpace() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._childGuids = null;
            return _this;
        }
        NSpace.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                var storeObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.pubStore()];
                        case 2:
                            storeObj = _a.sent();
                            storeObj.addUpdateCb(this, "ddsUpdateCb");
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        NSpace.prototype.getNamespace = function () {
            return this.getPubKey("ns", true);
        };
        NSpace.prototype.getExtendedNamespace = function () {
            return __awaiter(this, void 0, void 0, function () {
                var pObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getParent()];
                        case 1:
                            pObj = _a.sent();
                            if (!(pObj !== null)) return [3 /*break*/, 3];
                            return [4 /*yield*/, pObj.getExtendedNamespace()];
                        case 2: return [2 /*return*/, (_a.sent()) + "." + this.getNamespace()];
                        case 3: return [2 /*return*/, this.getNamespace()];
                    }
                });
            });
        };
        NSpace.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        NSpace.prototype.getParent = function () {
            return __awaiter(this, void 0, void 0, function () {
                var pGuid;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            pGuid = this.getPubKey("pGuid", true);
                            if (!(pGuid !== null)) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.getService().getNamespaces().getByGuid(pGuid)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [2 /*return*/, null];
                    }
                });
            });
        };
        NSpace.prototype.getChildren = function (cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, _a, rObjs, _b, _c, _i, guid, rObj;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            if (!(this._childGuids === null)) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.newRequest()];
                        case 1:
                            reqObj = _d.sent();
                            reqObj.setL1("Users").setL2("Get").setL3("ByEasGuid");
                            reqObj.addReq("guid", this.getGuid());
                            _a = this;
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 2:
                            _a._childGuids = _d.sent();
                            _d.label = 3;
                        case 3:
                            rObjs = [];
                            _b = [];
                            for (_c in this._childGuids)
                                _b.push(_c);
                            _i = 0;
                            _d.label = 4;
                        case 4:
                            if (!(_i < _b.length)) return [3 /*break*/, 7];
                            guid = _b[_i];
                            return [4 /*yield*/, this.getService().getNamespaces().getByGuid(guid, cbObj, cbMethod)];
                        case 5:
                            rObj = _d.sent();
                            rObjs.push(rObj);
                            _d.label = 6;
                        case 6:
                            _i++;
                            return [3 /*break*/, 4];
                        case 7: return [2 /*return*/, rObjs];
                    }
                });
            });
        };
        NSpace.prototype.getChildByNamespace = function (ns, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            return __awaiter(this, void 0, void 0, function () {
                var rObjs, i, rObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getChildren()];
                        case 1:
                            rObjs = _a.sent();
                            for (i = 0; i < rObjs.length; i++) {
                                rObj = rObjs[i];
                                if (rObj.getNamespace() === ns) {
                                    return [2 /*return*/, rObj];
                                }
                            }
                            if (throwOnErr === true) {
                                throw this.getMtm().newException("Child namespace does not exist: " + ns);
                            }
                            else {
                                return [2 /*return*/, null];
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        NSpace.prototype.ddsUpdateCb = function (storeObj) {
            this._childGuids = null;
        };
        NSpace.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getNamespaces().clearCache(this);
        };
        return NSpace;
    }(Base));

    var Namespaces = /** @class */ (function (_super) {
        __extends(Namespaces, _super);
        function Namespaces() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Namespaces.prototype.newObj = function () {
            var rObj = new NSpace();
            rObj.setService(this.getService());
            return rObj;
        };
        Namespaces.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        Namespaces.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("Namespaces").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_1 = _a.sent();
                            throw errObj_1;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return Namespaces;
    }(BaseFactory));

    var RoleNsMap = /** @class */ (function (_super) {
        __extends(RoleNsMap, _super);
        function RoleNsMap() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RoleNsMap.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        RoleNsMap.prototype.getNamespace = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getNetworks().getByGuid(this.getPubKey("nsGuid", true))];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RoleNsMap.prototype.getRole = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getRoles().getByGuid(this.getPubKey("roleGuid", true))];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RoleNsMap.prototype.getUser = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getUsers().getByGuid(this.getPubKey("userGuid", true))];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RoleNsMap.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        RoleNsMap.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getRoleNsMaps().clearCache(this);
        };
        return RoleNsMap;
    }(Base));

    var RoleNsMaps = /** @class */ (function (_super) {
        __extends(RoleNsMaps, _super);
        function RoleNsMaps() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RoleNsMaps.prototype.newObj = function () {
            var rObj = new RoleNsMap();
            rObj.setService(this.getService());
            return rObj;
        };
        RoleNsMaps.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        RoleNsMaps.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("RoleNsMaps").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_1 = _a.sent();
                            throw errObj_1;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return RoleNsMaps;
    }(BaseFactory));

    var RolePriviligeMap = /** @class */ (function (_super) {
        __extends(RolePriviligeMap, _super);
        function RolePriviligeMap() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RolePriviligeMap.prototype.construct = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.baseConstruct(apiObj)];
                        case 1:
                            _a.sent();
                            this.setInit();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        RolePriviligeMap.prototype.getRole = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getRoles().getByGuid(this.getPubKey("roleGuid", true))];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RolePriviligeMap.prototype.getPrivilege = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getService().getPrivileges().getByGuid(this.getPubKey("privGuid", true))];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        RolePriviligeMap.prototype.getCreated = function () {
            return this.getPubKey("created", true);
        };
        RolePriviligeMap.prototype.terminate = function (throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.setTerm();
            this.getService().getRolePriviligeMaps().clearCache(this);
        };
        return RolePriviligeMap;
    }(Base));

    var RolePriviligeMaps = /** @class */ (function (_super) {
        __extends(RolePriviligeMaps, _super);
        function RolePriviligeMaps() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        RolePriviligeMaps.prototype.newObj = function () {
            var rObj = new RolePriviligeMap();
            rObj.setService(this.getService());
            return rObj;
        };
        RolePriviligeMaps.prototype.getByApiObj = function (apiObj) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof this._s[apiObj.guid] === "undefined") {
                                this._s[apiObj.guid] = this.newObj();
                                this._s[apiObj.guid].construct(apiObj);
                            }
                            return [4 /*yield*/, this._s[apiObj.guid].waitInit()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this._s[apiObj.guid]];
                    }
                });
            });
        };
        RolePriviligeMaps.prototype.getByGuid = function (guid, cbObj, cbMethod) {
            if (cbObj === void 0) { cbObj = null; }
            if (cbMethod === void 0) { cbMethod = null; }
            return __awaiter(this, void 0, void 0, function () {
                var reqObj, apiObj, rObj, errObj_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(typeof this._s[guid] !== "undefined")) return [3 /*break*/, 2];
                            return [4 /*yield*/, this._s[guid].waitInit()];
                        case 1:
                            _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](this._s[guid]);
                            }
                            return [2 /*return*/, this._s[guid]];
                        case 2: return [4 /*yield*/, this.newRequest()];
                        case 3:
                            reqObj = _a.sent();
                            reqObj.setL1("RolePriviligeMaps").setL2("Get").setL3("ByGuid");
                            reqObj.addReq("guid", guid);
                            _a.label = 4;
                        case 4:
                            _a.trys.push([4, 7, , 8]);
                            return [4 /*yield*/, reqObj.getResponse(true)];
                        case 5:
                            apiObj = _a.sent();
                            return [4 /*yield*/, this.getByApiObj(apiObj)];
                        case 6:
                            rObj = _a.sent();
                            if (cbObj !== null && cbMethod !== null) {
                                cbObj[cbMethod](rObj);
                            }
                            return [2 /*return*/, rObj];
                        case 7:
                            errObj_1 = _a.sent();
                            throw errObj_1;
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return RolePriviligeMaps;
    }(BaseFactory));

    var DcUnrApi = /** @class */ (function () {
        function DcUnrApi(_dcScc, _dcEasApi) {
            this._dcScc = _dcScc;
            this._dcEasApi = _dcEasApi;
            this._connFact = null;
            this._uFact = null;
            this._nsFact = null;
            this._nrmFact = null;
            this._rpmFact = null;
            this._roleFact = null;
            this._privFact = null;
            this._ddsClient = null;
            this._dcScc.getMtm().set("DcUnrApi", this);
        }
        DcUnrApi.prototype.getDcScc = function () {
            return this._dcScc;
        };
        DcUnrApi.prototype.getMtm = function () {
            return this.getDcScc().getMtm();
        };
        DcUnrApi.prototype.getLogging = function () {
            return this.getDcScc().getLogging();
        };
        DcUnrApi.prototype.getConnection = function () {
            if (this._connFact === null) {
                this._connFact = new Connection();
                this._connFact.setService(this);
                this._connFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._connFact;
        };
        DcUnrApi.prototype.getRoleNsMaps = function () {
            if (this._nrmFact === null) {
                this._nrmFact = new RoleNsMaps();
                this._nrmFact.setService(this);
                this._nrmFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._nrmFact;
        };
        DcUnrApi.prototype.getRolePriviligeMaps = function () {
            if (this._rpmFact === null) {
                this._rpmFact = new RolePriviligeMaps();
                this._rpmFact.setService(this);
                this._rpmFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._rpmFact;
        };
        DcUnrApi.prototype.getNamespaces = function () {
            if (this._nsFact === null) {
                this._nsFact = new Namespaces();
                this._nsFact.setService(this);
                this._nsFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._nsFact;
        };
        DcUnrApi.prototype.getPrivileges = function () {
            if (this._privFact === null) {
                this._privFact = new Privileges();
                this._privFact.setService(this);
                this._privFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._privFact;
        };
        DcUnrApi.prototype.getRoles = function () {
            if (this._roleFact === null) {
                this._roleFact = new Roles();
                this._roleFact.setService(this);
                this._roleFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._roleFact;
        };
        DcUnrApi.prototype.getUsers = function () {
            if (this._uFact === null) {
                this._uFact = new Users();
                this._uFact.setService(this);
                this._uFact.setExceptionCb(this.getLogging(), "exception");
            }
            return this._uFact;
        };
        DcUnrApi.prototype.getDdsClient = function () {
            return __awaiter(this, void 0, void 0, function () {
                var ddsHost, ddsPort, ddsSsl;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!(this._ddsClient === null)) return [3 /*break*/, 2];
                            ddsHost = "dc-wss-nlb.datacamo.net";
                            ddsPort = 28106;
                            ddsSsl = true;
                            this._ddsClient = this.getMtm().get("DcDdsApi").getClients().getV1(ddsHost, ddsPort, ddsSsl);
                            return [4 /*yield*/, this._ddsClient.initialize()];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/, this._ddsClient];
                    }
                });
            });
        };
        DcUnrApi.prototype.newRequest = function () {
            return __awaiter(this, void 0, void 0, function () {
                var cObj, cObj;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getConnection().getClient()];
                        case 1:
                            cObj = _a.sent();
                            return [4 /*yield*/, cObj.isAuth()];
                        case 2:
                            cObj = _a.sent();
                            return [2 /*return*/, cObj.newMessage()];
                    }
                });
            });
        };
        return DcUnrApi;
    }());
    DcUnrApi.ɵprov = i0.ɵɵdefineInjectable({ factory: function DcUnrApi_Factory() { return new DcUnrApi(i0.ɵɵinject(i1.DcScc), i0.ɵɵinject(i2.DcEasApi)); }, token: DcUnrApi, providedIn: "root" });
    DcUnrApi.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    DcUnrApi.ctorParameters = function () { return [
        { type: i1.DcScc },
        { type: i2.DcEasApi }
    ]; };

    /*
     * Public API Surface of dc-unr-api
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.DcUnrApi = DcUnrApi;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dc-unr-api.umd.js.map
